/*
 * version.h
 *
 * Version number header file for OpenMCU conferencing server
 *
 * Copyright (c) 1993-2000 Equivalence Pty. Ltd.
 *
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.0 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific language governing rights and limitations
 * under the License.
 *
 * Portions of ths code were written by by Post Increment (http://www.postincrement.com) 
 * with the assistance of funding from Stonevoice, slc. http://www.stonevoice.com
 *
 * The Original Code is Portable Windows Library.
 *
 * The Initial Developer of the Original Code is Equivalence Pty. Ltd.
 *
 * Contributor(s): Derek J Smithies (derek@indranet.co.nz)
 *                 Craig Southeren (craig@postincrement.com)
 *
 * $Log: version.h,v $
 * Revision 1.4  2009/05/30 15:18:40  willamowius
 * version 2.2.5
 *
 * Revision 1.3  2008/02/19 06:36:11  shorne
 * Added ability to have 16CIF & 4CIF size video. Thx Marcos Jardini for the initial 4CIF patch
 *
 * Revision 1.2  2007/10/20 12:32:53  shorne
 * first h323plus release
 *
 * Revision 1.1  2007/10/17 19:44:37  shorne
 * Initial Commit
 *
 * Revision 2.10  2006/06/09 04:45:52  csoutheren
 * Incremented version number
 *
 * Revision 2.9  2006/06/09 04:39:59  csoutheren
 * Migrated VideoBranch to main trunk
 *
 * Revision 2.8.2.4  2006/04/06 01:11:16  csoutheren
 * Latest sources include
 *   - premedia blanking and optional image display
 *   - ablity to defer conference join for authentication if required
 *   - more bulletproofing on conference join
 *   - new video copy/fill functions
 *
 * Revision 2.8.2.3  2006/04/06 00:50:30  csoutheren
 * Latest changes (more to come)
 *
 * Revision 2.8.2.2  2006/03/28 05:13:38  csoutheren
 * Normalised file headers
 * Fixed problem with QCIF video
 * Seperated H.323 and MCU process functions into seperate files
 *
 */

#ifndef _OpenMCU_VERSION_H
#define _OpenMCU_VERSION_H

#define MAJOR_VERSION 2
#define MINOR_VERSION 2
#define BUILD_TYPE    ReleaseCode
#define BUILD_NUMBER  5


#endif  // _OpenMCU_VERSION_H


// End of File ///////////////////////////////////////////////////////////////
